/*----- PROTECTED REGION ID(CanberraAIM556Class.h) ENABLED START -----*/
//=============================================================================
//
// file :        CanberraAIM556Class.h
//
// description : Include for the CanberraAIM556 root class.
//               This class is the singleton class for
//                the CanberraAIM556 device class.
//               It contains all properties and methods which the 
//               CanberraAIM556 requires only once e.g. the commands.
//
// project :     MCA Canberra AIM 556
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef CanberraAIM556Class_H
#define CanberraAIM556Class_H

#include <tango.h>
#include <CanberraAIM556.h>


/*----- PROTECTED REGION END -----*/	//	CanberraAIM556Class.h


namespace CanberraAIM556_ns
{
/*----- PROTECTED REGION ID(CanberraAIM556Class::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	CanberraAIM556Class::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute ADC class definition
class ADCAttrib: public Tango::Attr
{
public:
	ADCAttrib():Attr("ADC",
			Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~ADCAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CanberraAIM556 *>(dev))->read_ADC(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CanberraAIM556 *>(dev))->write_ADC(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CanberraAIM556 *>(dev))->is_ADC_allowed(ty);}
};

//	Attribute Mode class definition
class ModeAttrib: public Tango::Attr
{
public:
	ModeAttrib():Attr("Mode",
			Tango::DEV_ENUM, Tango::READ_WRITE) {};
	~ModeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CanberraAIM556 *>(dev))->read_Mode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CanberraAIM556 *>(dev))->write_Mode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CanberraAIM556 *>(dev))->is_Mode_allowed(ty);}
	virtual bool same_type(const type_info &in_type) {return typeid(ModeEnum) == in_type;}
	virtual string get_enum_type() {return string("ModeEnum");}
};

//	Attribute Channels class definition
class ChannelsAttrib: public Tango::Attr
{
public:
	ChannelsAttrib():Attr("Channels",
			Tango::DEV_ULONG, Tango::READ_WRITE) {};
	~ChannelsAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CanberraAIM556 *>(dev))->read_Channels(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CanberraAIM556 *>(dev))->write_Channels(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CanberraAIM556 *>(dev))->is_Channels_allowed(ty);}
};

//	Attribute PresetLiveTime class definition
class PresetLiveTimeAttrib: public Tango::Attr
{
public:
	PresetLiveTimeAttrib():Attr("PresetLiveTime",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~PresetLiveTimeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CanberraAIM556 *>(dev))->read_PresetLiveTime(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CanberraAIM556 *>(dev))->write_PresetLiveTime(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CanberraAIM556 *>(dev))->is_PresetLiveTime_allowed(ty);}
};

//	Attribute PresetRealTime class definition
class PresetRealTimeAttrib: public Tango::Attr
{
public:
	PresetRealTimeAttrib():Attr("PresetRealTime",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~PresetRealTimeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CanberraAIM556 *>(dev))->read_PresetRealTime(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CanberraAIM556 *>(dev))->write_PresetRealTime(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CanberraAIM556 *>(dev))->is_PresetRealTime_allowed(ty);}
};

//	Attribute LiveTime class definition
class LiveTimeAttrib: public Tango::Attr
{
public:
	LiveTimeAttrib():Attr("LiveTime",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~LiveTimeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CanberraAIM556 *>(dev))->read_LiveTime(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CanberraAIM556 *>(dev))->is_LiveTime_allowed(ty);}
};

//	Attribute RealTime class definition
class RealTimeAttrib: public Tango::Attr
{
public:
	RealTimeAttrib():Attr("RealTime",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~RealTimeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CanberraAIM556 *>(dev))->read_RealTime(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CanberraAIM556 *>(dev))->is_RealTime_allowed(ty);}
};

//	Attribute Data class definition
class DataAttrib: public Tango::SpectrumAttr
{
public:
	DataAttrib():SpectrumAttr("Data",
			Tango::DEV_ULONG, Tango::READ, 65536) {};
	~DataAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CanberraAIM556 *>(dev))->read_Data(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CanberraAIM556 *>(dev))->is_Data_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command On class definition
class OnClass : public Tango::Command
{
public:
	OnClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OnClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OnClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CanberraAIM556 *>(dev))->is_On_allowed(any);}
};

//	Command Off class definition
class OffClass : public Tango::Command
{
public:
	OffClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OffClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OffClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CanberraAIM556 *>(dev))->is_Off_allowed(any);}
};

//	Command Reset class definition
class ResetClass : public Tango::Command
{
public:
	ResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ResetClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CanberraAIM556 *>(dev))->is_Reset_allowed(any);}
};

//	Command ClearMemory class definition
class ClearMemoryClass : public Tango::Command
{
public:
	ClearMemoryClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ClearMemoryClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ClearMemoryClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CanberraAIM556 *>(dev))->is_ClearMemory_allowed(any);}
};


/**
 *	The CanberraAIM556Class singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  CanberraAIM556Class : public Tango::DeviceClass
#else
class CanberraAIM556Class : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(CanberraAIM556Class::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556Class::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static CanberraAIM556Class *init(const char *);
		static CanberraAIM556Class *instance();
		~CanberraAIM556Class();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		CanberraAIM556Class(string &);
		static CanberraAIM556Class *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	CanberraAIM556_H
